-- main for remove_background.love

function love.load()
	gr, li, lf	= love.graphics, love.image, love.filesystem
	gr.setCaption( 'Background Removal' )
	image			= gr.newImage('Love.jpg')
	width, height	= gr.getWidth(), gr.getHeight()
	gr.setBackgroundColor( 55, 255, 55, 255 )
	effect = gr.newPixelEffect [[
		//extern vec4 remove;
		extern vec4 Cmin;
		extern vec4 Cmax;
		vec4 effect(vec4 color,Image tex,vec2 tc,vec2 pc)
		{	vec4 pixel = Texel(tex,tc);
			if ((pixel.r<=Cmax.r && pixel.r>=Cmin.r) &&
				(pixel.g<=Cmax.g && pixel.g>=Cmin.g) &&
				(pixel.b<=Cmax.b && pixel.b>=Cmin.b))
			{pixel.a        = 0;}
			return pixel;
		}
		]]
	remove_range = {
		r = { 0, 125 },
		g = { 0, 255 },
		b = { 0, 255 }
		}
	remove_min = {remove_range.r[1]/255,remove_range.g[1]/255,remove_range.b[1]/255,1}
	remove_max = {remove_range.r[2]/255,remove_range.g[2]/255,remove_range.b[2]/255,1}
	effect:send('Cmin',remove_min)
	effect:send('Cmax',remove_max)
	change = false
	end

function love.draw()
	gr.setColorMode( 'replace' )
	add_grid()
	if change then
		gr.setPixelEffect( effect )
		gr.draw( image )
		gr.setPixelEffect()
		else
		gr.draw( image )
		end
	gr.setColor(255,255,255,255)
	gr.print( 'Press <r> to change background to transparent.', 10, 10 )
	gr.print( love.timer.getFPS(), gr.getWidth()-30, 10 )
	end

function love.update(dt) end

function love.keypressed(key)
	if key == 'escape'	then love.event.push( 'quit' )	end
	if key == 'r'		then change = not change end
	end

function add_grid()
	gr.setColor( 0, 0, 0, 255 )
	for i = 0, width, 20 do
		gr.line( i, 0, i, height )
		end
	for j = 0, height, 20 do
		gr.line( 0, j, width, j )
		end
	end

